



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Mysql - 性能优化之子查询</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Mysql - 性能优化之子查询</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 13:24:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>记得在做项目的时候, 听到过一句话, 尽量不要使用子查询, 那么这一篇就来看一下, 这句话是否是正确的.</p>
<p>那在这之前, 需要介绍一些概念性东西和mysql对语句的大致处理.</p>
<p>当Mysql Server的连接线程接收到Client发送过来的SQL请求后, 会经过一系列的分解Parse, 进行相应的分析, 然后Mysql会通过查询优化器模块, 根据该Sql所涉及到的数据表的相关统计信息进行计算分析. 然后在得出一个Mysql自认为最合理最优化的数据访问方式, 也就是我们常说的"执行计划", 然后根据所得到的执行计划通过调用存储引擎接口来获取相应数据. 再对存储引擎返回的数据进行相关的处理, 并一Client端所要求的格式作为结果集, 返回给Client.</p>
<p>注 : 这里所说的统计数据, 是我们通过 Analyze table命令通知Mysql对表的相关数据作分析之后, 所获取到的一些数据统计量. 这些数据对Mysql优化器而言是非常重要的, 优化器所生成的执行计划的好坏, 主要是由这些统计数据所决定的.</p>
<p>1. 建表</p>
<div>
<pre class="prettyprint linenums">create table User(<br />
　　Id int not null PRIMARY key auto_increment ,<br />
　　NickName varchar(50) comment '用户昵称',<br />
　　Sex int comment '性别',<br />
　　Sign varchar(50) comment '用户签名',<br />
　　Birthday datetime comment '用户生日',<br />
　　CreateTime datetime comment '创建时间'<br />
) default charset=utf8 comment '用户表';

create table UserGroup(<br />
　　Id int not null PRIMARY key auto_increment ,<br />
　　UserId int not null comment 'user Id',<br />
　　GroupId int not null comment '用户组Id',<br />
　　CreateTime datetime comment '创建时间',<br />
　　-- key index_groupid(GroupId) using btree,<br />
　　key index_userid(groupid, UserId) using btree<br />
) default charset=utf8 comment '用户组表';</pre>
</div>
<p>2. 准备数据</p>
<div>
<pre class="prettyprint linenums">var conStr = ConfigurationManager.ConnectionStrings["ConStr"].ToString();<br />
using (IDbConnection conn = new MySqlConnection(conStr))<br />
{<br />
    Stopwatch watch = new Stopwatch();<br />
    var sql = string.Empty;<br />
    var names = new string[] { "非", "想", "红", "帝", "德", "看", "梅", "插", "兔" };<br />
    Random ran = new Random();<br />
    var insertSql = @" insert into User(NickName,Sex,Sign, Birthday, CreateTime) values(@NickName,@Sex,@Sign, @Birthday, @CreateTime);<br />
    INSERT INTO usergroup  (UserId,  GroupId,  CreateTime )  VALUES (LAST_INSERT_ID() ,   @GroupId,  @CreateTime);";<br />
    watch.Start();<br />
    if (conn.State == ConnectionState.Closed)<br />
    {<br />
        conn.Open();<br />
    }

    var tran = conn.BeginTransaction();<br />
    for (int i = ; i &lt; ; i++)<br />
    {<br />
        var param = new { NickName = names[ran.Next()] + names[ran.Next()] + i, Sign = names[ran.Next()] + names[ran.Next()], CreateTime = DateTime.Now, Birthday = DateTime.Now.AddYears(ran.Next(, )), Sex = i % , GroupId = ran.Next(, ) };<br />
        conn.Execute(insertSql, param, tran);<br />
    }<br />
    tran.Commit();

    conn.Dispose();<br />
    watch.Stop();<br />
    Console.WriteLine(watch.ElapsedMilliseconds);<br />
}</pre>
</div>
<p>这里我插入了5000条数据, group分了99个组, 随机的.</p>
<p>3. 查询sql</p>
<div>
<pre class="prettyprint linenums"> explain<br />
select user.id, user.nickname from usergroup<br />
left join user  on usergroup.UserId = user.Id<br />
where  usergroup.groupid = 1<br />
order by usergroup.UserId desc<br />
limit 100, 20;

 explain<br />
select user.id, user.nickname<br />
from (select id, userid from usergroup where groupid = 1 order by userid limit 100, 20) t<br />
left join  user on t.UserId = user.id ;

 explain<br />
select user.id, user.nickname<br />
from (select id, userid from usergroup where groupid = 1 order by userid ) t<br />
left join  user on t.UserId = user.id<br />
limit 100, 20;</pre>
</div>
<p>第二句和第三句都使用到了子查询, 不同之处再与, 第二句是先得到20条数据, 然后以此来与user表关联的</p>
<p>4. 分析</p>
<p>100000条数据情况下 :</p>
<p>先看第一句</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/640690/201612/640690-20161230164951179-1621784096.png" /></p>
<p>再看第二句</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/640690/201612/640690-20161230165207898-155957557.png" /></p>
<p>第三句</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/640690/201612/640690-20161230165236320-2087468600.png" /></p>
<p>从上面三幅图看, 好像能看出点什么了.</p>
<p>首先看他们的 rows, 第二句最多, 加起来有1000多了, 另两句加起来都是996. 但是我想说的是, 这里并不是看rows的和是多少. 正确的方式是, 从id大的语句开始看, id相同的语句, 从上到下依次执行.</p>
<p>那先看第二句的id=2的语句和第一句的id=1的语句, 一模一样的. 他们都是从usergroup表中筛选数据, 并且能得到相同的结果集A.</p>
<p>看来他们都是基于相同的结果集去进行操作, 接下来就有区别了.</p>
<p>先看第一句, 再结果集A的基础上, 去左连接表user, 并筛选出最后的数据, 返回给客户端.</p>
<p>那第二句呢, 是在A的基础上, 再次筛选数据, 得到需要的数据, 然后拿这些数据, 去与user表左连接, 得到最终结果.</p>
<p>从上面来看, 执行计划中, 第二种执行计划, 更加高效.</p>
<p>如果能够通过子查询, 大幅度缩小查询范围, 可以考虑使用子查询语句.</p>
<p>参考:</p>
<p>　　<a href="https://my.oschina.net/wcsm520/blog/222694" rel="external nofollow noreferrer">Mysql性能优化explain</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvj4jqx.html">玩转Windows服务系列&amp;mdash&semi;&amp;mdash&semi;给Windows服务添加COM接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q25wkxq.html">360急速浏览器BUG，POST表单提交参数丢失</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1jrd5q.html">为什么不要使用Response&period;Close&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq47dx0q.html">最小和&lpar;min&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rg4w9.html">Fragment详解之三&mdash;&mdash;管理Fragment（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ez1jx8.html">Velocity魔法堂系列一：入门示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v7nzn8.html">java程序  输入10个数字并求和</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj4vlq.html">Linux系统编程&commat;多线程编程&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgxjr8.html">java的nio之：java的nio系列教程之serverSocketChannel</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5jro8.html">【原】ubuntu下Mysql的HA（corosync&plus;pacemaker&plus;drbd）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy155v2q.html">记录&mdash;&mdash;时间轮定时器（lua 实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp24xjq.html">（十五）qt-tcp</a>
		</li>
						<li><a href="https://www.batexi.com/a/96perey8.html">Linux Centos6&period;9下安装部署VNC的实操详述</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1lxloq.html">C&num;使用Selenium&plus;PhantomJS抓取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxzklq.html">信步漫谈之Jenkins&amp;mdash&semi;集成环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wp3kgq.html">【Ubuntu16&period;04&period;4】常用配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjr6wq.html">Codeforces Round &num;488 Div&period; 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emgv2z9.html">Web开发者的福利 30段超实用CSS代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pplgmd9.html">SteamVR Unity Plugin - v2&period;0&period;1中的InteractionSystem</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ple1nq.html">【Loj&num;535】花火（线段树，扫描线）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/or93xn93.html">先说IEnumerable，我们每天用的foreach你真的懂它吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/kjqdvzqd.html">StringMVC 中如何做数据校验</a>
			</li>
						<li><a href="https://www.batexi.com/a/6o8kw38j.html">ASP&period;NET Core 折腾笔记二：自己写个完整的Cache缓存类来支持&period;NET Core</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e1ej91.html">使用Visual Studio 2015 开发ASP&period;NET MVC 5 项目部署到Mono&sol;Jexus</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zok3qy.html">如何正确使用日志Log</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdwz09d.html">&lbrack;C&num;&rsqb; 了解过入口函数 Main&lpar;&rpar; 吗？带你用批处理玩转 Main 函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2kgxq7.html">前端性能优化的另一种方式&mdash;&mdash;HTTP2&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvzyo9x.html">【开源】专业K线绘制&lbrack;K线主副图、趋势图、成交量、滚动、放大缩小、MACD、KDJ等）</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql5218o.html">mysql 行级锁的使用以及死锁的预防</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96563q4.html">keepalive的不足，如何处理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
